.\" Copyright (c) 1980, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From: @(#)lastcomm.1	8.1 (Berkeley) 6/6/93
.\" $FreeBSD: src/usr.bin/lastcomm/lastcomm.1,v 1.7.2.4 2002/06/21 15:27:39 charnier Exp $
.\" $DragonFly: src/usr.bin/lastcomm/lastcomm.1,v 1.3 2008/05/02 02:05:07 swildner Exp $
.\"
.Dd September 18, 1996
.Dt LASTCOMM 1
.Os
.Sh NAME
.Nm lastcomm
.Nd show last commands executed in reverse order
.Sh SYNOPSIS
.Nm
.Op Fl EScesu
.Op Fl f Ar file
.Op Ar command ...\&
.Op Ar user ...\&
.Op Ar terminal ...\&
.Sh DESCRIPTION
The
.Nm
utility gives information on previously executed commands.
With no arguments,
.Nm
prints information about all the commands recorded
during the current accounting file's lifetime.
.Pp
The following options are available:
.Pp
.Bl -tag -width XXfXfileX -compact
.It Fl E
Print the time the process exited.
.It Fl S
Print the time the process started.
.It Fl c
Print the amount of cpu time used by the process.
.It Fl e
Print the amount of elapsed time used by the process.
.It Fl s
Print the amount of system time used by the process.
.It Fl u
Print the amount of user time used by the process.
.It Fl f Ar file
Read from
.Ar file
rather than the default
.Pa /var/account/acct .
.El
.Pp
If no options are specified,
.Fl cS
is assumed.
If
.Nm
is invoked with arguments, only accounting entries with a
matching
.Ar command
name,
.Ar user
name,
or
.Ar terminal
name
are printed.
For example:
.Pp
.Dl lastcomm a.out root ttyd0
.Pp
would produce a listing of all the
executions of commands named
.Pa a.out
by user
.Ar root
on the terminal
.Ar ttyd0  .
.Pp
For each process entry, the following are printed.
.Pp
.Bl -bullet -offset indent -compact
.It
The name of the user who ran the process.
.It
Flags, as accumulated by the accounting facilities in the system.
.It
The command name under which the process was called.
.It
The amount of
CPU
.Pq Fl c ,
wall
.Pq Fl e ,
system
.Pq Fl s ,
or user
.Pq Fl u
time used by the process (in seconds).
.It
The time the process started
.Pq Fl S
or exited
.Pq Fl E .
.El
.Pp
The flags are encoded as follows: ``S'' indicates the command was
executed by the super-user, ``F'' indicates the command ran after
a fork, but without a following
.Xr exec 3 ,
.\" ``C'' indicates the command was run in PDP-11 compatibility mode
.\" (VAX only),
``D'' indicates the command terminated with the generation of a
.Pa core
file, and ``X'' indicates the command was terminated with a signal.
.Sh FILES
.Bl -tag -width /var/account/acct -compact
.It Pa /var/account/acct
Default accounting file.
.El
.Sh SEE ALSO
.Xr last 1 ,
.Xr sigvec 2 ,
.Xr acct 5 ,
.Xr core 5
.Sh HISTORY
The
.Nm
command appeared in
.Bx 3.0 .
